
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class CurrenciesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const currencies = await db.currencies.create(
            {
                id: data.id || undefined,
        
        code: data.code
        ||
        null
            ,
            
        name: data.name
        ||
        null
            ,
            
        symbol: data.symbol
        ||
        null
            ,
            
        minor_unit: data.minor_unit
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await currencies.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return currencies;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const currenciesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                code: item.code
            ||
            null
            ,
            
                name: item.name
            ||
            null
            ,
            
                symbol: item.symbol
            ||
            null
            ,
            
                minor_unit: item.minor_unit
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const currencies = await db.currencies.bulkCreate(currenciesData, { transaction });

        // For each item created, replace relation files
        

        return currencies;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const currencies = await db.currencies.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.code !== undefined) updatePayload.code = data.code;
        
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.symbol !== undefined) updatePayload.symbol = data.symbol;
        
        
        if (data.minor_unit !== undefined) updatePayload.minor_unit = data.minor_unit;
        
        
        updatePayload.updatedById = currentUser.id;

        await currencies.update(updatePayload, {transaction});

        
        
        if (data.organizations !== undefined) {
            await currencies.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return currencies;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const currencies = await db.currencies.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of currencies) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of currencies) {
                await record.destroy({transaction});
            }
        });


        return currencies;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const currencies = await db.currencies.findByPk(id, options);

        await currencies.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await currencies.destroy({
            transaction
        });

        return currencies;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const currencies = await db.currencies.findOne(
            { where },
            { transaction },
        );

        if (!currencies) {
            return currencies;
        }

        const output = currencies.get({plain: true});

        
        
        
        
        
        
        
        
        
        output.contacts_currency = await currencies.getContacts_currency({
            transaction
        });
        
        
        
        
        
        output.quotes_currency = await currencies.getQuotes_currency({
            transaction
        });
        
        
        
        output.invoices_currency = await currencies.getInvoices_currency({
            transaction
        });
        
        
        
        output.bills_currency = await currencies.getBills_currency({
            transaction
        });
        
        
        
        output.expenses_currency = await currencies.getExpenses_currency({
            transaction
        });
        
        
        output.bank_accounts_currency = await currencies.getBank_accounts_currency({
            transaction
        });
        
        
        output.bank_transactions_currency = await currencies.getBank_transactions_currency({
            transaction
        });
        
        
        output.payments_currency = await currencies.getPayments_currency({
            transaction
        });
        
        
        
        
        
        
        
        output.organizations = await currencies.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'currencies',
                        'code',
                        filter.code,
                    ),
                };
            }
            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'currencies',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.symbol) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'currencies',
                        'symbol',
                        filter.symbol,
                    ),
                };
            }
            

            
            

            
            if (filter.minor_unitRange) {
                const [start, end] = filter.minor_unitRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    minor_unit: {
                    ...where.minor_unit,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    minor_unit: {
                    ...where.minor_unit,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.currencies.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'currencies',
                        'code',
                        query,
                    ),
                ],
            };
        }

        const records = await db.currencies.findAll({
            attributes: [ 'id', 'code' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['code', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.code,
        }));
    }

    
};

